#!/usr/bin/env python
# encoding: utf-8

"""
Producing then compiling templates
"""

from bopytex.scheduler import Scheduler
import bopytex.default_config as DEFAULT


def orcherstrator(
    options: dict,
    planner,
    dispatcher,
):
    tasks = planner(options)

    scheduler = Scheduler(dispatcher, [options["template"]])
    scheduler.append(tasks)

    for message in scheduler.backlog():
        yield message

def main(**options):

    config = options.copy()
    config["jinja2"] = {}
    config["jinja2"]["environment"] = DEFAULT.jinja2_env

    orcherstre = orcherstrator(
        config, planner=DEFAULT.planner, dispatcher=DEFAULT.dispatcher
    )
    for message in orcherstre:
        yield message

# -----------------------------
# Reglages pour 'vim'
# vim:set autoindent expandtab tabstop=4 shiftwidth=4:
# cursor: 16 del
